import { EANService } from './ean.service';

describe('EANService', () => {
  const eans = new EANService();
  test('generates valid EAN-13 checksum', () => {
    const sum = eans.calcChecksum('400638133393');
    expect(sum).toBe(1);
  });

  test('always returns num of correct length', () => {
    const initial = 140000000000n;
    for (let i = 0; i < 100; i += 1) {
      const ean = eans.fromID((initial + BigInt(i)).toString(10));
      if (ean.length !== 13) console.log(ean);
      expect(ean.length).toBe(13);
    }
  });
});
