import { Module } from '@nestjs/common';
import { TypeOrmModule } from '@nestjs/typeorm';
import { Connection } from 'typeorm';
import { ItemsResolver } from './items.resolver';
import { ItemsService } from './items.service';
import { Item } from './items.entity';
import { EANService } from './ean/ean.service';

@Module({
  imports: [TypeOrmModule.forFeature([Item])],
  providers: [ItemsResolver, ItemsService, EANService],
})
export class ItemsModule {
  constructor(private connection: Connection) {}
}
